<?php

namespace Org;

class Sms
{
    // 保存错误信息
    public $error;
    // Access Key ID
    // private $accessKeyId = 'LTAIDNyoAM647d7O';
    private $accessKeyId = 'b44004226c153dbd68af3d247143aac6';
    // Access Access Key Secret
    // private $accessKeySecret = 'MMmqqs8rC1DDQ3VMEcYVEpaSdaS0e3';
    private $accessKeySecret = 'NGw7u5QpZJ3g72MG';
    // 签名
    private $signName = 'Kinglaundry';
    // 模版ID
    private $templateList = array(
        'verify_code' => 'SMS_156455036', //验证码
        'yuyue_code' => 'SMS_157281205', //预约码
        'order_succ' => 'SMS_157276294', //下单成功
        'new_notify' => 'SMS_157276310', //有新订单，通知配送员
        'finish_notify' => 'SMS_157276310', //订单完成，通知用户取件
        'machine_full' => 'SMS_157281909', //爆仓提醒
    );

    public function __construct($cofig = array())
    {
    }

    /**
     * @param unknown $mobile
     * @param unknown $verify_code
     *
     */
    public function send($mobile, $tpl = '', $params = array())
    {
        $params = array( //此处作了修改
            'SignName' => $this->signName,
            'Format' => 'JSON',
            'Version' => '2024-07-25',
            'AccessKeyId' => $this->accessKeyId,
            'SignatureVersion' => '1.0',
            'SignatureMethod' => 'HMAC-SHA1',
            'SignatureNonce' => uniqid(),
            'Timestamp' => gmdate('Y-m-d\TH:i:s\Z'),
            'Action' => 'SendSms',
            'TemplateCode' => $this->templateList[$tpl],
            'PhoneNumbers' => '66' . intval($mobile),
            //'TemplateParam' => '{"code":"' . $verify_code . '"}'
            'TemplateParam' => json_encode($params),
        );

        $header = array( //此处作了修改
            'Content-Type' => 'application/json',
            'api_key' => $this->accessKeyId,
            'secret_key' => $this->accessKeySecret
        );

        // $Username = "rada.richness";
        // $Password = "kV23Fx5w@";
        $PhoneList = $mobile;
        $Message = $params['TemplateParam'];

        $Sender = "EasyWash24";
        // $Sender = "Demo-SMS";

        $Params = is_array($Message) ? $Message : json_decode($Message, 1);

        switch ($tpl) {
            case 'verify_code':
                $title = 'ยืนยัน Code : ' . $Params['code'];
                break;
            case 'yuyue_code':
                $title = 'นัดล่วงหน้า Code :' . $Params['code'];
                break;
            case 'order_succ':
                $title = 'ทำรายการสำเร็จ';
                break;
            case 'new_notify':
                $title = 'มีออร์เดอร์ใหม่ แจ้งพนักงาน';
                break;
            case 'finish_notify':
                $title = 'ทำรายการสำเร็จ' . "\n" . sprintf("CODE: %s \nAddress: %s", $Params['code'] ?? '-', $Params['address']);
                $Message = null;
                break;
            case 'machine_full':
                $title = 'แจ้งล็อกเกอร์เต็ม';
                break;
            default:
                $title = $tpl;
        }

        $Message = $title . ($Message ? $Message : '');

        $Parameter = array( //此处作了修改
            'phone' => $PhoneList,
            'message' => $Message,
            'sender' => $Sender
        );

        $Header = array( //此处作了修改
            'Content-Type' => 'application/json',
            'api_key' => $this->accessKeyId,
            'secret_key' => $this->accessKeySecret
        );
        
        $API_URL = "https://portal-otp.smsmkt.com/api/otp-send";

        $curl = curl_init();

        curl_setopt_array($curl, array(
            CURLOPT_URL => 'https://portal-otp.smsmkt.com/api/send-message',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => json_encode($Parameter),
            CURLOPT_HTTPHEADER => array(
                'Content-Type: application/json',
                'api_key: b7c2a81cadd34fbe3c4baee3eac3de88',
                'secret_key: yy83wMszDUGwYM96'
              ),
          ));

        // curl_setopt($ch, CURLOPT_URL, $API_URL);
        // curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        // curl_setopt($ch, CURLOPT_POST, 1);
        // curl_setopt($ch, CURLOPT_POSTFIELDS, $Parameter);
        // curl_setopt($ch, CURLOPT_HTTPHEADER, array(
        //     'Content-Type: application/json',
        //     'api_key: b44004226c153dbd68af3d247143aac6',
        //     'secret_key: NGw7u5QpZJ3g72MG'
        //   ));

        $Result = curl_exec($curl);
        $http_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
        curl_close($curl);

        return true;

        //var_dump($params);die;
        // 计算签名并把签名结果加入请求参数
        $params['Signature'] = $this->computeSignature($params, $this->accessKeySecret);
        // 发送请求
        $url = 'http://dysmsapi.aliyuncs.com/?' . http_build_query($params);

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_TIMEOUT, 10);
        $result = curl_exec($ch);
        curl_close($ch);
        $result = json_decode($result, true);
        var_dump($result);

        $msg = '[' . date('Y-m-d H:i:s') . ']' . "\n";
        $msg .= $mobile . "\n" . json_encode($result) . "\n";
        file_put_contents('logs/sms/' . date('Y-m-d') . '.log', $msg, FILE_APPEND);

        if (isset($result['Code']) && $result['Code'] == 'OK') {
            return true;
        } else {
            $this->error = $this->getErrorMessage($result['Code']);
            return false;
        }
    }

    private function percentEncode($string)
    {
        $string = urlencode($string);
        $string = preg_replace('/\+/', '%20', $string);
        $string = preg_replace('/\*/', '%2A', $string);
        $string = preg_replace('/%7E/', '~', $string);
        return $string;
    }

    /**
     * 签名
     *
     * @param unknown $parameters
     * @param unknown $accessKeySecret
     * @return string
     */
    private function computeSignature($parameters, $accessKeySecret)
    {
        ksort($parameters);
        $canonicalizedQueryString = '';
        foreach ($parameters as $key => $value) {
            $canonicalizedQueryString .= '&' . $this->percentEncode($key) . '=' . $this->percentEncode($value);
        }
        $stringToSign = 'GET&%2F&' . $this->percentencode(substr($canonicalizedQueryString, 1));
        $signature = base64_encode(hash_hmac('sha1', $stringToSign, $accessKeySecret . '&', true));
        return $signature;
    }

    /**
     * 获取详细错误信息
     *
     * @param unknown $status
     */
    public function getErrorMessage($status)
    {
        // 阿里云的短信 乱八七糟的(其实是用的阿里大于)
        // https://api.alidayu.com/doc2/apiDetail?spm=a3142.7629140.1.19.SmdYoA&apiId=25450
        $message = array(
            'InvalidDayuStatus.Malformed' => '账户短信开通状态不正确',
            'InvalidSignName.Malformed' => '短信签名不正确或签名状态不正确',
            'InvalidTemplateCode.MalFormed' => '短信模板Code不正确或者模板状态不正确',
            'InvalidRecNum.Malformed' => '目标手机号不正确，单次发送数量不能超过100',
            'InvalidParamString.MalFormed' => '短信模板中变量不是json格式',
            'InvalidParamStringTemplate.Malformed' => '短信模板中变量与模板内容不匹配',
            'InvalidSendSms' => '触发业务流控',
            'InvalidDayu.Malformed' => '变量不能是url，可以将变量固化在模板中',
        );
        if (isset($message[$status])) {
            return $message[$status];
        }
        return $status;
    }
}
